<?php
// Отправляем браузеру правильную кодировку,
// файл login.php должен быть в кодировке UTF-8 без BOM.
header('Content-Type: text/html; charset=UTF-8');

// Начинаем сессию.
session_start();

// Инициализируем переменные для подключения к базе данных.
$db_user = 'u21226';   // Логин БД
$db_pass = '7755808';  // Пароль БД

// В суперглобальном массиве $_SESSION хранятся переменные сессии.
// Будем сохранять туда логин после успешной авторизации.
// Если в сесси уже существует логин, значит пользователь уже авторизован.
if (!empty($_SESSION['login'])) {
  // Перенаправлем его в форму.
  header('Location: ./');
}

// В суперглобальном массиве $_SERVER PHP сохраняет некторые заголовки запроса HTTP
// и другие сведения о клиненте и сервере, например метод текущего запроса $_SERVER['REQUEST_METHOD'].
if ($_SERVER['REQUEST_METHOD'] == 'GET') {
?>

<form action="" method="post">
  <input name="login" placeholder="Ваш логин" />
  <input name="pass" placeholder="Ваш пароль" />
  <input type="submit" value="Войти" />
</form>

<?php
}
// Иначе, если запрос был методом POST, т.е. нужно сделать авторизацию с записью логина в сессию.
else {

  // Инициализируем логин и пароль из глобального массива $_POST.
  $login = $_POST['login'];
  // Не забываем захэшировать пароль с помощью алгоритма sha256.
  $pass =  hash('sha256', $_POST['pass'], false);

  $db = new PDO('mysql:host=localhost;dbname=u21226', $db_user, $db_pass, array(
    PDO::ATTR_PERSISTENT => true
  ));

  // Пытаемся достать данные пользователя из БД.
  try {
    // Подготавливаем SQL запрос, где вопросы заменятся на значения.
    // Запрос направляется в таблицу users с данными пользователей
    // и достает из нее все значения, где login = логину пользователя.
    $stmt = $db->prepare("SELECT * FROM users WHERE login = ?");
    // Заменяем вопросы на значения.
    $stmt->execute(array(
      $login
    ));
    // Получаем данные в виде массива из БД.
    $user = $stmt->fetch();

    // Сравнием текущий хэш пароля с тем, что достали из базы.
    if ($pass == $user['pass']) {
      // Если он верныйы, то записываем логин в сессию.
      $_SESSION['login'] = $login;
    }
    else {
      // Иначе выводим пользователю информацию об ошибке.
      echo "Неправильный логин или пароль";
      // Прекращаем работу скрипта.
      exit();
    }

  }
  catch(PDOException $e) {
    // При возникновении ошибки получения данных из БД, выводим информацию
    // об ошибке пользователю.
    echo 'Ошибка: ' . $e->getMessage();
    // Прекращаем работу скрипта.
    exit();
  }

  // Делаем перенаправление.
  header('Location: ./');
}
